#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "lista.h"

#define FONT_PLD (char*) "-ult1mo-arial-bold-r-normal-*-*-720-*-*-p-*-adobe-fontspecific"
#define FONT_LINUX (char*) "-ult1mo-arial-bold-r-normal-*-*-120-*-*-p-*-adobe-fontspecific"
#define FONT (char*) "-b&h-lucida-bold-r-normal-*-*-120-*-*-p-*-iso8859-2"

static GdkPixmap *obrazek = NULL;
gint poz = 370;
gint pozt = 0;
gint klatka = 1;
gint effect = 0;
gint howmuch=0;
gint y, y_to_wrap_at;
gchar *filename; 

gboolean
on_obszar_rys_expose_event (GtkWidget * widget,
			    GdkEventExpose * event, gpointer user_data)
{
	gdk_draw_pixmap (widget->window,
			 widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
			 obrazek, event->area.x, event->area.y,
			 event->area.x, event->area.y, event->area.width,
			 event->area.height);
	return FALSE;
}


gboolean
on_obszar_rys_configure_event (GtkWidget * widget,
			       GdkEventConfigure * event,
			       gpointer user_data)
{
	if (obrazek)
		gdk_pixmap_unref (obrazek);

	obrazek = gdk_pixmap_new (widget->window,
				  widget->allocation.width,
				  widget->allocation.height, -1);

	gdk_draw_rectangle (obrazek,
			    widget->style->black_gc,
			    TRUE,
			    0, 0,
			    widget->allocation.width,
			    widget->allocation.height);

	return TRUE;
}


gint draw_scroll (gpointer user_data)
{
	if (effect != klatka) {
		g_print ("\n\tRuning effect_%d\n", klatka);
		effect = klatka;
	}
	switch (klatka) {
	case 1:
		efekt_1 (user_data);
		break;

	case 2:
		efekt_2 (user_data);
		break;

	case 3:
		efekt_3 (user_data);
		break;

	case 4:
		klatka = 1;
		g_print ("Back to frame 1\n");
		break;

	default:
		klatka = 1;
	}
	return TRUE;
}

gint efekt_1 (gpointer user_data)
{
	GtkWidget *obszar_rys = (GtkWidget *) user_data;
	GdkFont *font = gdk_font_load (FONT_PLD);
	GdkFont *font2 = gdk_font_load (FONT_LINUX);
	GdkRectangle uakt_prost;
	gint totalwidth;

	if (!font) {
		fprintf (stderr, "Error font %s not found!.\n", FONT_PLD);
		gtk_main_quit ();
		return FALSE;
	}
	if (!font2) {
		fprintf (stderr, "Error font %s not found!.\n",
			 FONT_LINUX);
		gtk_main_quit ();
		return FALSE;
	}


	gdk_draw_rectangle (obrazek,
			    obszar_rys->style->
			    fg_gc[GTK_WIDGET_STATE (obszar_rys)], TRUE, 0,
			    0, obszar_rys->allocation.width,
			    obszar_rys->allocation.height);

	if (poz > 170)
		poz--;
	else {
		poz = 170;
		klatka++;
	}

	totalwidth = gdk_string_width (font, "PLD");

	g_print ("\e[1GScroll poz = %d", poz);
	gdk_draw_string (obrazek,
			 font,
			 obszar_rys->style->white_gc,
			 (obszar_rys->allocation.width -
			  totalwidth) / 2, poz, "PLD");

	gdk_draw_line (obrazek,
		       obszar_rys->style->white_gc,
		       (obszar_rys->allocation.width - totalwidth) / 2,
		       poz + 5,
		       obszar_rys->allocation.width -
		       ((obszar_rys->allocation.width - totalwidth) / 2),
		       poz + 5);

	totalwidth = gdk_string_width (font2, "Linux Distribution");

	gdk_draw_string (obrazek,
			 font2,
			 obszar_rys->style->white_gc,
			 (obszar_rys->allocation.width -
			  totalwidth) / 2, poz + 22, "Linux Distribution");

	uakt_prost.x = 0;
	uakt_prost.y = 0;
	uakt_prost.width = obszar_rys->allocation.width;
	uakt_prost.height = obszar_rys->allocation.height;

	gtk_widget_draw (obszar_rys, &uakt_prost);

	return TRUE;
}

gint efekt_2 (gpointer user_data)
{
	GtkWidget *obszar_rys = (GtkWidget *) user_data;
	GdkRectangle uakt_prost;

	if (poz > 70)
		poz--;
	else {
		poz = 300;
		pozt = poz;
		y = poz;
		klatka++;
	}

	g_print ("\e[1GScroll poz = %d   ", poz);

	gdk_draw_line (obrazek,
		       obszar_rys->style->black_gc,
		       0, poz + 35, 300, poz + 35);
	gdk_draw_line (obrazek,
		       obszar_rys->style->black_gc,
		       0, 170 + (170 - poz), 300, 170 + (170 - poz));
	gdk_draw_line (obrazek,
		       obszar_rys->style->black_gc,
		       0, 60 + (170 - poz), 300, 60 + (170 - poz));

	uakt_prost.x = 0;
	uakt_prost.y = 0;
	uakt_prost.width = obszar_rys->allocation.width;
	uakt_prost.height = obszar_rys->allocation.height;

	gtk_widget_draw (obszar_rys, &uakt_prost);

	return TRUE;
}


gint efekt_3 (gpointer user_data)
{
	GtkWidget *obszar_rys = (GtkWidget *) user_data;
	GdkFont *font = gdk_font_load (FONT);
	GdkRectangle uakt_prost;
	gint cury, i, totalwidth, totalheight;

	if (!font) {
		fprintf (stderr, "Error font %s not found!.\n", FONT);
		gtk_main_quit ();
		return FALSE;
	}

	y_to_wrap_at =
	    -(sizeof (lista) / sizeof (lista[0])) * (font->ascent +
						     font->descent);
	totalheight =
	    (pozt / 2) +
	    ((sizeof (lista) * gdk_string_height (font, "PLD")) / 2);

	i = 0;
	cury = y;
	gdk_draw_rectangle (obrazek, obszar_rys->style->black_gc,
			    TRUE,
			    0, 0,
			    obszar_rys->allocation.width,
			    obszar_rys->allocation.height);

	while (lista[i]) {
		totalwidth = gdk_string_width (font, _(lista[i]));

		g_print ("\e[1GScroll poz = %d", poz);

		if (cury > -font->descent &&
		    cury < obszar_rys->allocation.height + font->ascent) {
			gdk_draw_string (obrazek,
					 font,
					 obszar_rys->style->white_gc,
					 (obszar_rys->allocation.width -
					  totalwidth) / 2,
					 cury, _(lista[i]));
		}

		i++;
		cury += font->ascent + font->descent;

	}

	y--;
	if (y < y_to_wrap_at)
		y = obszar_rys->allocation.height + font->ascent;

	if (poz < totalheight)
		poz++;
	else {
		poz = 370;
		klatka = 1;
	}
	uakt_prost.x = 0;
	uakt_prost.y = 0;
	uakt_prost.width = obszar_rys->allocation.width;
	uakt_prost.height = obszar_rys->allocation.height;

	gtk_widget_draw (obszar_rys, &uakt_prost);

	return TRUE;
}

gboolean
on_window1_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if (howmuch >= 4)
		return FALSE;

	switch (event->keyval) {
	case GDK_d:
	case GDK_D:
		if (howmuch == 2) {
			howmuch=0;
			filename = gnome_datadir_file ("PLD-About/lista.dat");
			if (filename)
				gnome_sound_play (filename);
			g_free (filename);
		}
		else
			howmuch = 0;
		break;
	case GDK_P:
	case GDK_p:
		if (howmuch == 0)
			howmuch++;
		else
			howmuch = 0;
		break;
	case GDK_L:
	case GDK_l:
		if (howmuch == 1)
			howmuch ++;
		else
			howmuch = 0;
		break;
	default:
		howmuch = 0;
	}

	return TRUE;
}

